#GUI GAME.py
import turtle

from tkinter import *
from random import randint

def move_player(event): #the function for player move
    key=event.keysym
    if key=='Right' and playerborder(key):
        c.move(player, 10, 0)
    elif key=='Left' and playerborder(key):
        c.move(player, -10, 0)
    elif key=='Down' and playerborder(key):
        c.move(player, 0, 10)
    elif key=='Up' and playerborder(key):
        c.move(player, 0, -10)

def playerborder(key): #the function which checks if the player in bounds - if not computer disallows player to move(to avoid cheeting)
    if key == 'Up' and c.coords(player)[1]>110: #check all keystates and check will it be in bounds if it moved
        return True
    elif key == 'Down' and c.coords(player)[3]<=500:
        return True
    elif key == 'Left' and c.coords(player)[0]>0:
        return True
    elif key == 'Right' and c.coords(player)[2]<=800:
        return True
    else:
        return False



def make_1coin(): #the function to make coins
    xp = randint(1,800) #the random x coordinate
    yp=0 #y coordinate for coin is always 0, b/c coin starts at top of screen
    s = randint(10, 30) #the size of coin (random)
    coin = c.create_oval(xp, yp, xp+s, yp+s, fill="yellow") #create coin
    coin_list.append(coin) #add coin to the coin array
    window.after(coin_timecreate, make_1coin) #recall function after time coin_timecreate

def make_1enemy(): #function that makes enemies (the red circles)
    xp = randint(1,800) #the random x coordinate
    yp=0 #y coordniate is always 0, b/c enemy starts at top of screen
    s = 20  #the size of an enemy ship
    enemy = c.create_oval(xp, yp, xp+s, yp+s, fill="red") #create enemy
    enemy_list.append(enemy) #add enemy to the enemy array
    window.after(enemy_timecreate, make_1enemy) #recall function after time enemy_timecreate

def enemyshoot(): #this function is when an enemy shoots a bullet
    for enemy in enemy_list: #create a bullet for ALL enemies
        bspec = randint(0, 100)
        if bspec>10:
            bullet = c.create_rectangle(c.coords(enemy)[0], c.coords(enemy)[1], c.coords(enemy)[0]+5, c.coords(enemy)[1]+20, fill='red') #makes a bullet according to the enemy position
            bullet_list.append(bullet) #add bullet to the bullet array
        else:
            bullet = c.create_rectangle(c.coords(enemy)[0], c.coords(enemy)[1], c.coords(enemy)[0]+5, c.coords(enemy)[1]+20, fill='green') #makes a bullet according to the enemy position
            bullet_spec_list.append(bullet) #add bullet to the bullet array
    window.after(bullet_timecreate, enemyshoot) #recall function after time bullet_timecreate
    

def garbagecollect(): # this function removes objects from memory that aren't anymore on screen (out of bound objects)
    global coin_list #reference all object lists because removing objects from them (modifying the lists)
    global enemy_list
    global bullet_list
    removelist = [] #the list to hold the items for remove query
    for i in coin_list: #go through all elements in coin list
        if c.coords(i)[1]>500: #check if object (coin) if out of bound
            removelist.append(i)  #if out of bound add to remove query
    for i in enemy_list: #go through all elements in enemy list
        if c.coords(i)[1]>500:
            removelist.append(i)
    for i in bullet_list: #go through all elements in bullet list
        if c.coords(i)[1]>500:
            removelist.append(i)
    for i in bullet_spec_list: #go through all elements in bullet list
        if c.coords(i)[1]>500 or c.coords(i)[1]<0 or c.coords(i)[0]<0 or c.coords(i)[0]>800:
            removelist.append(i)
    for i in removelist: #go though al elements in removelist (the list to hold items on remove query)
        c.delete(i) #remove object from screen
        if i in coin_list:   # remove object from their list
            coin_list.remove(i)
        elif i in enemy_list:
            enemy_list.remove(i)
        elif i in bullet_list:
            bullet_list.remove(i)
        elif i in bullet_spec_list:
            bullet_spec_list.remove(i)
    window.after(gbcollecttimeout, garbagecollect) #recall function after time gbcollecttimeout

def move_coin_enemy(): #this function move enemy and coin
    for i in range(len(coin_list)): #go though all elements and move them
        #yfall = randint(0, 2)
        #xfall = randint(-1, 1)
        yfall=1
        xfall=0
        c.move(coin_list[i], 0, yfall)
    for i in range(len(enemy_list)):
        #yfall = randint(0, 2)
        #xfall = randint(-1, 1)
    
        yfall=1
        xfall=0
        c.move(enemy_list[i], 0, yfall)
        
    plycoords = c.coords(player)
    px=plycoords[0]
    py=plycoords[1]
    for i in range(len(bullet_list)):
        #yfall = randint(0, 2)
        #xfall = randint(-1, 1)
        yfall=40
        xfall=0
        c.move(bullet_list[i], 0, yfall)
        
    for i in range(len(bullet_spec_list)):
        #yfall = randint(0, 2)
        #xfall = randint(-1, 1)
        xoff=randint(0, 3)
        yoff=randint(0, 5)
        xf=5
        yf=5
        bulletG = 5
        if px>c.coords(bullet_spec_list[i])[0]:
            xfall=xf-xoff
        else:
            xfall=-xf+xoff
        if py>c.coords(bullet_spec_list[i])[1]:
            yfall=yf-yoff+bulletG
        else:
            yfall=-yf+yoff+bulletG
        #yfall=40
        #xfall=0
        c.move(bullet_spec_list[i], xfall, yfall)
    window.after(coin_timemove, move_coin_enemy)


        
def check_hits(): #this function checks EVERY overlapping
    global score
    global level
    global highscore
    global bullet_timecreate
    overlap = c.find_overlapping(c.coords(player)[0], c.coords(player)[1], c.coords(player)[2], c.coords(player)[3]) #check all objects overlapping and player
    for v in bullet_list: #go over all bullets and check if it hitted player
        if v in overlap: #if bullet hitted player
            level_display.config(text='You died. Restarted. Level: 1')
            if score>highscore: #if current score is bigger than old high score
                highscore=score #update highscore
                highscore_display.config(text='High Score: ' + str(highscore)) #update highcore display
            bullet_timecreate=4000   #reset the bullet time creation, as player is back to level 1
            score=0 #set score to 0
            level=1 #set level to 1
    for v in bullet_spec_list: #go over all bullets and check if it hitted player
        if v in overlap: #if bullet hitted player
            level_display.config(text='You died. Restarted. Level: 1')
            if score>highscore: #if current score is bigger than old high score
                highscore=score #update highscore
                highscore_display.config(text='High Score: ' + str(highscore)) #update highcore display
            bullet_timecreate=4000   #reset the bullet time creation, as player is back to level 1
            score=0 #set score to 0
            level=1 #set level to 1
            
    for v in coin_list: #check if player collected a coin
        if v in overlap:
            c.delete(v)   #remove coin from screen
            coin_list.remove(v)  #remove coin from list
            score+=1  #add to score b/c player collected a coin
    score_display.config(text='Score: ' + str(score))
    levelsc=10 # the score required for the player to step up 1 level
    if score>=(levelsc*level): #check if player can step up 1 level
        level+=1
        if (bullet_timecreate-(200*(level-1)))>=500:
            bullet_timecreate=bullet_timecreate-200*(level-1)
        level_display.config(text='Level: ' + str(level))  #update level
        #score_display.config(text='Score: ' + str(score))
    window.after(hitstimeout, check_hits) #recall function after time hitstimeout
    
# TEST AREA
window = Tk()  #create the tk window
window.title('ENEMY SHIPS')
window.geometry('800x600')

c = Canvas(window, width=800, height=500, bg='black') #create the canvas widget (the game main screen)
c.pack() #put canvas widget on screen
c.bind_all('<Key>', move_player) #bind ALL keys to function move_player as keys are only used to move the player

player = c.create_rectangle(390, 190, 390+20, 190+20, fill='orange') #create the player object
#coin = c.create_oval(100, 100, 120, 120, fill='yellow')
highscore=0 #the highscore variable
highscore_display = Label(window, text='High Score: ' + str(highscore)) #update the highscroe display
highscore_display.pack()

score=0 #score variable
score_display = Label(window, text='Score: ' + str(score))
score_display.pack()

level=1 #level variable
level_display = Label(window, text='Level: ' + str(level))
level_display.pack()

#coinarray = make_coins(10)
coin_list = [] #coin list to hold all coin objects
coin_timecreate=1000 #the frequency the coin should be created
window.after(coin_timecreate, make_1coin)

enemy_list = [] #enemy list ot hold all enemy objects
enemy_timecreate=3500 #the frequency the enemy should be created
window.after(enemy_timecreate, make_1enemy)

bullet_list = [] #the list to hold all bullet objects
bullet_spec_list = []
bullet_timecreate=4000 #the frequency an enemy should shoot (create a bullet)
window.after(bullet_timecreate, enemyshoot)

coin_timemove=100 #the frequency when a coin should move
window.after(coin_timemove, move_coin_enemy)

gbcollecttimeout=1000 #the frequency the garbagecollector should run. This doesn't have to run that frequently
window.after(gbcollecttimeout, garbagecollect)

hitstimeout=100 #the frequency the program should check if there is a hit (player-coin, player-bullet)
window.after(hitstimeout, check_hits)
