# Gabor ETCHASKETCH.py
import turtle

from tkinter import *

def forwardEvent(event=None):
    bob.fd(speed)

def rightEvent(event=None):
    bob.rt(speed)

def leftEvent(event=None):
    bob.lt(speed)

def backwardEvent(event=None):
    bob.backward(speed)

def speedUpEvent(event=None):
    global speed
    speed+=1
    display.config(text="speed: " + str(speed))

def speedDownEvent(event=None):
    global speed
    if speed>=2:
        speed-=1
    display.config(text="speed: " + str(speed))

def penUp(event=None):
    bob.penup()

def penDown(event=None):
    bob.pendown()

# TEST AREA
window = Tk()
window.title('ETCH A SKETCH APP')
window.geometry('800x600')
window.bind('<Left>', leftEvent)
window.bind('<Right>', rightEvent)
window.bind('<Down>', backwardEvent)
window.bind('<Up>', forwardEvent)
window.bind('<Next>', speedDownEvent)
window.bind('<Prior>', speedUpEvent)
window.bind('u', penUp)
window.bind('d', penDown)

c = Canvas(window, width=800, height=400)
c.pack()
speed=5

bob = turtle.RawTurtle(c)

fb = Button(window, command=forwardEvent, text="Forward")
fb.pack()
sdb = Button(window, command=backwardEvent, text="Backwards")
sdb.pack()
rb = Button(window, command=rightEvent, text="Right")
rb.pack()
lb = Button(window, command=leftEvent, text="Left")
lb.pack()
sub = Button(window, command=speedUpEvent, text="Speed Up")
sub.pack()
sdb = Button(window, command=speedDownEvent, text="Slow down")
sdb.pack()
sdb = Button(window, command=penUp, text="pen up")
sdb.pack()
sdb = Button(window, command=penDown, text="pen down")
sdb.pack()

display = Label(window, text="speed: " + str(speed))
display.pack()

window.mainloop()
