# GaborGroupProject
import turtle

def hills(t, sX=900, sY=700, stX=-450, stY=-360): # default values set to maintain default window size
    # Made by Gabor
    # t=the turtle object, sX=size X, sY=size Y, stX=down-left starting x point, stY=down-left starting y point
    # these hills are random, there are random fd, lt, rt values to draw the hills
    # I have custom colors for all the hills, got them off w3 schools color picker, they are in hex format
    # first hill
    t.begin_fill() # first hill (main biggest hill) drawing starting here
    t.fillcolor('#e68a00')
    t.width(10) # set width to 10 to get a border for the hill
    t.pencolor('#995c00') # set the pen color to set the border color
    t.penup()
    t.setpos(stX, stY)
    t.pendown()
    t.fd(sX)
    t.lt(90)
    t.fd(sY)
    t.lt(135)
    t.fd(200)
    t.rt(110)
    t.fd(50)
    t.lt(90)
    t.fd(150)
    t.rt(100)
    t.fd(80)
    t.lt(140)
    t.fd(210)
    t.rt(100)
    t.fd(300)
    t.lt(90)
    t.fd(120)
    t.rt(135)
    t.fd(85)
    t.lt(150)
    t.fd(120)
    t.rt(110)
    t.setpos(stX, stY+700) # I used setpos (set position of turtle using exact coordinate) at lots of places because it makes it easier to maintain coordinates than experimenting and "mathing" with fd, rt, lt
    t.setpos(stX, stY)
    t.end_fill()
    #second hill
    t.begin_fill()
    t.pencolor('#804000')
    t.fillcolor('#b35c00')
    t.setpos(stX+sX, stY)
    t.setpos(stX+sX, stY+400)
    t.setheading(180)
    t.fd(500)
    t.lt(10)
    t.fd(170)
    t.setpos(stX, stY+550)
    t.setpos(stX, stY)
    t.end_fill()
    t.setheading(140)
    
    
    # third hill
    
    inHillOffset=0 # this is the hill offset above the ground. Only used for testing
    t.penup()   # second hill (1. subhill) drawing starting here
    t.setpos(stX+inHillOffset, stY+inHillOffset)
    t.pendown()
    t.begin_fill()
    t.fillcolor('#663d00')
    t.pencolor('#4d2800')
    t.rt(140)
    t.fd(sX-inHillOffset*2)
    t.lt(90)
    t.fd(200)
    t.lt(60)
    t.fd(100)
    t.lt(90)
    t.fd(100)
    t.rt(110)
    t.fd(200)
    t.lt(95)
    t.fd(200)
    t.rt(100)
    t.fd(230)
    t.lt(90)
    t.fd(170)
    t.rt(80)
    t.fd(90)
    t.setpos(stX+inHillOffset, stY+inHillOffset+240)
    t.setpos(stX+inHillOffset, stY+inHillOffset)
    t.end_fill()
    # fourth hill
    inHillOffset2 = 0    #the hill offset for the third hill
    t.setpos(stX+inHillOffset+inHillOffset2, stY+inHillOffset+inHillOffset2) # third hill (2. subhill) drawing starting here
    t.begin_fill()
    t.pencolor('#333333')
    t.fillcolor('#1a0f00')
    t.rt(135)
    t.fd(sX-(inHillOffset+inHillOffset2)*2)
    t.lt(120)
    t.fd(100)
    t.lt(80)
    t.fd(50)
    t.rt(70)
    t.fd(120)
    t.lt(90)
    t.fd(130)
    t.rt(80)
    t.fd(200)
    t.lt(110)
    t.fd(100)
    t.rt(90)
    t.fd(140)
    t.lt(80)
    t.fd(50)
    t.rt(90)
    t.setpos(stX+inHillOffset+inHillOffset2, stY+inHillOffset+inHillOffset2+190)
    t.setpos(stX+inHillOffset+inHillOffset2, stY+inHillOffset+inHillOffset)
    t.end_fill()
    # at the end we should have tree layers of hills
    t.width(1) # reset width, so it won't interfer with other functions
    t.color('black') # reset color, so it won't interfer with other functions
    t.fillcolor('black') # reset fillcolor, so it won't interfer with other functions
    t.pencolor('black') # reset pencolor, so it won't interfer with other functions

def tree(t, stX, stY, s=1): #set default value to size
    # Made by Gabor
    # argument syntax t=the turtle object, stX=down-left starting x point, stY=down-left starting y point, s=size of the tree, default set to 1
    t.penup()
    t.setpos(stX, stY)
    t.pendown()
    t.begin_fill() # starting the tree trunk
    t.color('#4d2e00') #hex color
    t.setheading(0)
    t.fd(10*s)
    t.lt(90)
    t.fd(30*s)
    t.lt(90)
    t.fd(10*s)
    t.lt(90)
    t.fd(30*s)
    t.end_fill()
    t.setpos(stX+5*s, stY+30*s)
    t.setheading(0)
    t.begin_fill()
    t.color('green') # starting the green part of the tree
    t.fd(30*s)
    t.lt(125)
    t.setpos(stX+10*s, stY+50*s)
    t.setheading(0)
    t.fd(20*s)
    t.lt(125)
    t.setpos(stX+5*s, stY+70*s)
    t.lt(45)
    t.setpos(stX-20*s, stY+50*s)
    t.setpos(stX, stY+50*s)
    t.setpos(stX-25*s, stY+30*s)
    t.setheading(0)
    t.fd(30*s)
    t.end_fill()
    t.color('black') #reset color, so it won't interfere with other functions
  
# TEST AREA    

turtle.tracer(0, 0) # to instantly print out the picture
t = turtle.Turtle()
hills(t)
tree(t, 200, 200, 1.2)
turtle.update()
