# GaborKatieWillRhysTurtleGroupProject.py
import turtle

# FUNCTION AREA

def hills(t, sX=900, sY=700, stX=-450, stY=-360): # default values set to maintain default window size
    # Made by Gabor
    # t=the turtle object, sX=size X, sY=size Y, stX=down-left starting x point, stY=down-left starting y point
    # these hills are random, there are random fd, lt, rt values to draw the hills
    # I have custom colors for all the hills, got them off w3 schools color picker, they are in hex format
    # first hill
    t.penup()
    t.setpos(stX, stY)
    t.setheading(0)
    t.pendown()
    t.begin_fill() # first hill (main biggest hill) drawing starting here
    t.fillcolor('#e68a00')
    t.width(10) # set width to 10 to get a border for the hill
    t.pencolor('#995c00') # set the pen color to set the border color
    t.fd(sX)
    t.lt(90)
    t.fd(sY)
    t.lt(135)
    t.fd(200)
    t.rt(110)
    t.fd(50)
    t.lt(90)
    t.fd(150)
    t.rt(100)
    t.fd(80)
    t.lt(140)
    t.fd(210)
    t.rt(100)
    t.fd(300)
    t.lt(90)
    t.fd(120)
    t.rt(135)
    t.fd(85)
    t.lt(150)
    t.fd(120)
    t.rt(110)
    t.setpos(stX, stY+700) # I used setpos (set position of turtle using exact coordinate) at lots of places because it makes it easier to maintain coordinates than experimenting and "mathing" with fd, rt, lt
    t.setpos(stX, stY)
    t.end_fill()
    #second hill
    t.begin_fill()
    t.pencolor('#804000')
    t.fillcolor('#b35c00')
    t.setpos(stX+sX, stY)
    t.setpos(stX+sX, stY+400)
    t.setheading(180)
    t.fd(500)
    t.lt(10)
    t.fd(170)
    t.setpos(stX, stY+550)
    t.setpos(stX, stY)
    t.end_fill()
    t.setheading(140)
    
    
    # third hill
    
    inHillOffset=0 # this is the hill offset above the ground. Only used for testing
    t.penup()   # second hill (1. subhill) drawing starting here
    t.setpos(stX+inHillOffset, stY+inHillOffset)
    t.pendown()
    t.begin_fill()
    t.fillcolor('#663d00')
    t.pencolor('#4d2800')
    t.rt(140)
    t.fd(sX-inHillOffset*2)
    t.lt(90)
    t.fd(200)
    t.lt(60)
    t.fd(100)
    t.lt(90)
    t.fd(100)
    t.rt(110)
    t.fd(200)
    t.lt(95)
    t.fd(200)
    t.rt(100)
    t.fd(230)
    t.lt(90)
    t.fd(170)
    t.rt(80)
    t.fd(90)
    t.setpos(stX+inHillOffset, stY+inHillOffset+240)
    t.setpos(stX+inHillOffset, stY+inHillOffset)
    t.end_fill()
    # fourth hill
    inHillOffset2 = 0    #the hill offset for the third hill
    t.setpos(stX+inHillOffset+inHillOffset2, stY+inHillOffset+inHillOffset2) # third hill (2. subhill) drawing starting here
    t.begin_fill()
    t.pencolor('#333333')
    t.fillcolor('#1a0f00')
    t.rt(135)
    t.fd(sX-(inHillOffset+inHillOffset2)*2)
    t.lt(120)
    t.fd(100)
    t.lt(80)
    t.fd(50)
    t.rt(70)
    t.fd(120)
    t.lt(90)
    t.fd(130)
    t.rt(80)
    t.fd(200)
    t.lt(110)
    t.fd(100)
    t.rt(90)
    t.fd(140)
    t.lt(80)
    t.fd(50)
    t.rt(90)
    t.setpos(stX+inHillOffset+inHillOffset2, stY+inHillOffset+inHillOffset2+190)
    t.setpos(stX+inHillOffset+inHillOffset2, stY+inHillOffset+inHillOffset)
    t.end_fill()
    # at the end we should have tree layers of hills
    t.width(1) # reset width, so it won't interfer with other functions
    t.color('black') # reset color, so it won't interfer with other functions
    t.fillcolor('black') # reset fillcolor, so it won't interfer with other functions
    t.pencolor('black') # reset pencolor, so it won't interfer with other functions

def tree(t, stX, stY, s=1): #set default value to size
    # Made by Gabor
    # argument syntax t=the turtle object, stX=down-left starting x point, stY=down-left starting y point, s=size of the tree, default set to 1
    t.penup()
    t.setpos(stX, stY)
    t.pendown()
    t.begin_fill() # starting the tree trunk
    t.color('#4d2e00') #hex color
    t.setheading(0)
    t.fd(10*s)
    t.lt(90)
    t.fd(30*s)
    t.lt(90)
    t.fd(10*s)
    t.lt(90)
    t.fd(30*s)
    t.end_fill()
    t.setpos(stX+5*s, stY+30*s)
    t.setheading(0)
    t.begin_fill()
    t.color('green') # starting the green part of the tree
    t.fd(30*s)
    t.lt(125)
    t.setpos(stX+10*s, stY+50*s)
    t.setheading(0)
    t.fd(20*s)
    t.lt(125)
    t.setpos(stX+5*s, stY+70*s)
    t.lt(45)
    t.setpos(stX-20*s, stY+50*s)
    t.setpos(stX, stY+50*s)
    t.setpos(stX-25*s, stY+30*s)
    t.setheading(0)
    t.fd(30*s)
    t.end_fill()
    t.color('black') #reset color, so it won't interfere with other functions


def rainbow(t):
    # made by Will
    colorList = ["red", "orange", "yellow", "green", "blue", "purple"] #color of the rainbow
    t.width(30)
    t.penup()
    t.left(90)
    t.goto(350,100) # reset turtle to rainbow starting position
    t.pendown()
    for i in range(6): #for loop for the multiple curves of the rainbow (red, orange, yellow, etc.)
        t.color(colorList[i]) # selecting the color form the colorlist based on the # runtime of the for loop
        t.circle(350- (i*25), 180) #move in, because as we draw more rainbow curves rainbow curves get more in
        t.penup() #reset turtle to rainbow starting position
        t.goto(350,100)
        t.rt(90)
        t.fd(30 + i*25)
        t.right(90)
        t.pendown()
        

def cloud(t):
    # made by Will
    ## transfer turtle position to draw the cloud
    t.penup()
    t.goto(-137, 200) #set turtle position
    t.rt(90)
    t.pendown()
    ## using circles to draw cloud curves
    t.begin_fill() #start filling in the cloud
    t.color('white') #cloud color is wight
    t.width(1)
    t.circle(50, 180) #drawing cloud curve
    t.rt(100)
    t.circle(60, 150)
    t.right(100)
    t.circle(80, 180)
    t.right(100)
    t.circle(50, 200)
    t.rt(70)
    t.circle(100, 50)
    t.rt(70)
    t.circle(50, 120)
    t.end_fill() # end the fill as cloud is drawen

def unicorn(t):

    stX=100
    stY=440
    t.penup()
    t.setpos(stX, stY)
    t.pendown()
    t.width(5)
    t.pu()
    t.right(90)
    t.fd(400)
    t.left(90)
    t.fd(55)
    t.pd()
    t.fd(15)
    t.left(90)
    for i in range(13):
        t.fd(2)
        t.right(4)
    t.left(45)
    t.fd(100)
    t.right(85)
    for i in range(12):
        t.fd(5)
        t.left(1)
    for i in range(10):
        t.fd(5)
        t.right(1)
    for i in range(3):
        t.bk(5)
        t.left(1)
    t.right(90)
    for i in range(12):
        t.fd(5)
        t.left(3)
    t.right(45)
    t.fd(60)
    t.right(35)
    for i in range(7):
        t.fd(3)
        t.left(3)
    t.left(108)
    t.fd(20)
    t.left(60)
    t.fd(20)
    t.left(25)
    t.fd(65)
    t.left(20)
    for i in range(5):
        t.fd(3)
        t.left(3)
    t.left(15)
    for i in range(15):
        t.fd(3)
        t.right(2)
    for i in range(23):
        t.back(3)
        t.left(2)
    t.left(120)
    t.fd(65)
    t.right(35)
    for i in range(7):
        t.fd(3)
        t.left(1)
    t.left(120)
    t.fd(20)
    t.left(55)
    t.fd(20)
    t.left(32)
    t.fd(70)
    t.left(20)
    for i in range(20):
        t.fd(3)
        t.right(1)
    for i in range(25):
        t.fd(3)
        t.left(3)
    # print(t.xcor(), t.ycor())
    for i in range(5):
        t.bk(3)
        t.right(3)
    t.right(90)
    for i in range(30):
        t.fd(3)
        t.right(5)
    t.right(5)
    for i in range(20):
        t.fd(6)
        t.left(1)
    for i in range(20):
        t.fd(3)
        t.left(9)
    t.left(15)
    for i in range(36):
        t.bk(3)
        t.right(5)
    for i in range(14):
        t.bk(3)
        t.right(1)
    t.penup()
    t.goto(stX + 213.07401614745976, stY + -202.64479327346208)
    t.pendown()
    t.right(120)
    for i in range(15):
        t.fd(3)
        t.left(2)
    for i in range(7):
        t.fd(4)
        t.right(1)
    for i in range(8):
        t.fd(5)
        t.right(3)
    # print(t.xcor(), t.ycor())
    for i in range(9):
        t.fd(4)
        t.left(5)
    for i in range(9):
        t.fd(4)
        t.left(18)
    for i in range(9):
        t.bk(4)
        t.right(7)
    for i in range(18):
        t.bk(4)
        t.right(1)
    for i in range(5):
        t.bk(4)
        t.right(16)
    print(t.xcor(), t.ycor())
    t.right(85)
    for i in range(18):
        t.bk(5)
        t.left(1)
    t.penup()
    t.goto(stX + 8.225978256468839, stY + -139.11914948052126)
    t.pendown()
    t.right(30)
    for i in range(10):
        t.fd(2)
        t.left(3)
    t.left(95)
    for i in range(10):
        t.fd(2)
        t.left(3)
    # print(t.xcor(), t.ycor())
    t.right(60)
    for i in range(9):
        t.fd(4)
        t.left(4)
    for i in range(4):
        t.fd(2)
        t.right(5)
    for i in range(8):
        t.fd(3)
        t.left(1)
    for i in range(5):
        t.fd(1)
        t.left(5)
    for i in range(11):
        t.fd(2)
        t.left(6)
    t.left(63)
   ########## print(t.xcor(), t.ycor())
    for i in range(10):
        t.fd(1)
        t.left(2)
    for i in range(10):
        t.fd(1)
        t.right(2)

    for i in range(10):
        t.bk(1)
        t.left(2)
    for i in range(6):
        t.bk(1)
        t.right(2)
    t.right(50)
    
    for i in range(9):
        t.fd(2)
        t.left(8)
    # print(t.xcor(), t.ycor())
    for i in range(15):
        t.fd(2)
        t.right(3)
    for i in range(9):
        t.fd(3)
        t.left(9)
    t.penup()
    t.goto(stX + -33.7071287510088, stY + -207.7589685925487)
    t.pendown()
    t.right(39)
    for i in range(11):
        t.fd(2)
        t.right(3)
    t.right(48)
    for i in range(16):
        t.fd(3)
        t.right(3)
    for i in range(16):
        t.fd(4)
        t.left(3)
    for i in range(6):
        t.fd(2)
        t.left(4)
    t.left(125)
    print(t.xcor(), t.ycor())
    for i in range(12):
        t.fd(3)
        t.right(3)
    t.penup()
    t.goto(stX + 59.9983492451632, stY + -285.6581350427362)
    t.pendown()
    t.right(175)
    t.fd(87)
    t.right(40)
    for i in range(15):
        t.fd(2)
        t.left(2)
    t.left(98)
    t.fd(10)

# TEST AREA    

#turtle.tracer(0, 0) # to instantly print out the picture
t = turtle.Turtle() #make the turtle object
turtle.bgcolor('light blue') #set the background color to light blue
rainbow(t) #draw the rainbow
hills(t) #draw the hills
t.setheading(90)
cloud(t) # draw a cloud
tree(t, 210, -250, 1.2)  #draw multiple trees
tree(t, 270, -150, 1.2)
tree(t, -100, -220, 1.2)
t.penup()
t.setpos(0, 0)
t.pendown()
unicorn(t)
#turtle.update()
